import random

debug=False

def genetic_optimize(population,fitness_function,mutation_function, mate_function,
                       mutation_probability,elite,maxiterations,params=None):
  
    print "max iterations =%d" % maxiterations
# How many winners from each generation?
    original_population_size=len(population)
    top_elite=int(elite*original_population_size)
    
    # Main loop
    for i in range(maxiterations):
        individual_scores=[(fitness_function(v),v) for v in population]
        individual_scores.sort(  )
        ranked_individuals=[v for (s,v) in individual_scores]

        # Start with the pure winners
        population=ranked_individuals[0:top_elite]

        # Add mutated and bred forms of the winners
        while len(population)<original_population_size:
            if random.random(  )<mutation_probability:
            
                # Mutation
                c=random.randint(0,top_elite)
                population.append(mutation_function(ranked_individuals[c],params))
            else:

                # Crossover

                c1=random.randint(0,top_elite)
                if debug:
                    print 'random individual 1 %d ' % c1
                c2=random.randint(0,top_elite)
		if debug:
                    print 'random individual 2 %d ' % c2
                population.append(mate_function(ranked_individuals[c1],ranked_individuals[c2],params))

        # Print current best score
        print 'best fitness score in iteration %d is %d ' % (i,individual_scores[0][0]), 
	print ' for individual %r ' % (individual_scores[0][1])
    	
	if individual_scores[0][0]==0:
	    return individual_scores[0][1]
    #returns the best solution   
    return individual_scores[0][1]
